unit PDSL.Constructors;

interface

uses
  PDSL.Expressions;

function Number(AValue: Integer): IExpression;
function Variable(const AName: string): IExpression;
function Add(Expr1, Expr2: IExpression): IExpression;
function Sub(Expr1, Expr2: IExpression): IExpression;
function Mul(Expr1, Expr2: IExpression): IExpression;
function Eq(Expr1, Expr2: IExpression): IExpression;
function IfThenElse(Expr1, Expr2, Expr3: IExpression): IExpression;
function Let(const AVarName: string; AVarValue, ABody: IExpression): IExpression;
function DefineFunc(const AParamName: string; ABody: IExpression): IExpression;
function CallFunc(const AFuncName: string; AParamValue: IExpression): IExpression;

implementation

function Number(AValue: Integer): IExpression;
begin
  Result := TNumber.Create(AValue);
end;

function Variable(const AName: string): IExpression;
begin
  Result := TVariable.Create(AName);
end;

function Add(Expr1, Expr2: IExpression): IExpression;
begin
  Result := TAdd.Create(Expr1, Expr2);
end;

function Sub(Expr1, Expr2: IExpression): IExpression;
begin
  Result := TSub.Create(Expr1, Expr2);
end;

function Mul(Expr1, Expr2: IExpression): IExpression;
begin
  Result := TMul.Create(Expr1, Expr2);
end;

function Eq(Expr1, Expr2: IExpression): IExpression;
begin
  Result := TEquals.Create(Expr1, Expr2);
end;

function IfThenElse(Expr1, Expr2, Expr3: IExpression): IExpression;
begin
  Result := TIfThenElse.Create(Expr1, Expr2, Expr3);
end;

function Let(const AVarName: string; AVarValue, ABody: IExpression): IExpression;
begin
  Result := TLet.Create(AVarName, AVarValue, ABody);
end;

function DefineFunc(const AParamName: string; ABody: IExpression): IExpression;
begin
  Result := TDefineFunc.Create(AParamName, ABody);
end;

function CallFunc(const AFuncName: string; AParamValue: IExpression): IExpression;
begin
  Result := TCallFunc.Create(AFuncName, AParamValue);
end;

end.
